
use tempdb
go

create table people (
 peoplexml xml
)
go

insert people values(
'<people><person name="Bob"/><person name="Mary"/></people>'
)
insert people values(
'<people><person name="Fred"/></people>'
)
insert people values(
'<people><person name="Alice"/></people>'
)
insert people values(
'<people><person name="Curly"/><person name="Larry"/><person name="Moe"/></people>'
)
go

select peoplexml.exist('/people/person[@name="Bob"]') from people

select peoplexml.value('/people[1]/person[1]/@name', 'varchar(20)') from people 


select peoplexml.query('data(/people/person/@name)') from people


-- one row per person

declare @x xml;
set @x = 
'
<people><person name="Bob"/><person name="Mary"/></people>
<people><person name="Fred"/></people>
<people><person name="Alice"/></people>
<people><person name="Curly"/><person name="Larry"/><person name="Moe"/></people>
';

select tab.col.value('data(@name)', 'varchar(20)') 
from 
@x.nodes('/people/person') as tab(col)

select tab.col.value('data(@name)', 'varchar(20)') 
from 
people
cross apply
peoplexml.nodes('/people/person') as tab(col)

declare @x xml
set @x = (select peoplexml from people for xml auto, type)
select @x.query('data(/people/peoplexml/people/person/@name)')



 